/**
 * Created on 1.6.2008, 0:59:10
 * @author Veikko Niemi
 */
/**         EditFiles
 * This program edits one or 2 lines length strings beginS,...,endS either replacing
 * or adding beginS,...,endS by replaceS
 * if adding then either beginS or endS must be included into replaceS and nothing
 * is deleted, only something addedimport javax.swing.JFileChooser;
 * if you want to convert all not skipped records f.ex. UPPER case then begin string and end string must be in same case
 * If skip start is selected but not end, program skips only individual "start" records
 * otherwise if also "end" skip string is filled, program skips all recors between them
 * now verify selection is implemented only running from source (by JAVA output in Netbeans or other IDE)
 * You may choose many inputs in one catalog at a time
 * It's best to first run the program with "simulate" selected or copying safecopys of inputs
 */
package editfiles;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.File;
import java.util.Scanner;
import java.util.Formatter;
import java.awt.event.*;
import java.awt.*;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.filechooser.FileFilter;
import javax.swing.*;

public class EditFiles extends JFrame {

    JPanel jpTiedot = new JPanel();
    JLabel lbBegin = new JLabel(" EDIT BEGIN text");
    JTextField tfBegin = new JTextField(10);
    JLabel lbEnd = new JLabel(" EDIT END text (optional)");
    JTextField tfEnd = new JTextField(10);
    JLabel lbReplace = new JLabel(" REPLACE text (optional)");
    JTextField tfReplace = new JTextField(10);
    JLabel lbStartSkip1 = new JLabel(" START SKIP 1 text (optional)");
    JTextField tfStartSkip1 = new JTextField(10);
    private String prevValue1 = ""; // tfStartSkip1 previous value
    JLabel lbEndSkip1 = new JLabel(" END SKIP 1 text (optional)");
    JTextField tfEndSkip1 = new JTextField(10);
    JPanel jpCheckBoxes = new JPanel();
    String[] cases = {"case", "to lower", "to UPPER"};
    boolean caseLine = true;                                // default selection
    boolean lowerLine = false;
    boolean upperLine = false;
    boolean filterHtml = false;
    boolean skipScript = false;
    boolean skipPhp = false;
    JComboBox jCase = new JComboBox(cases);
    JCheckBox fHtml = new JCheckBox("Filter htm/html/php");
    JCheckBox nLines = new JCheckBox("2 lines strings");
    JCheckBox sScript = new JCheckBox("Skip <script");
    JCheckBox sPhp = new JCheckBox("Skip <?php");
    JCheckBox simulate = new JCheckBox("Simulate only");
    JCheckBox noVerify = new JCheckBox("No verify");
    JCheckBox jcbadd = new JCheckBox("No replace - ADD");
    JPanel jpPainikkeet = new JPanel();
    JButton btStart = new JButton("START");
    JButton btFinish = new JButton("FINISH");
    Container cSisalto = this.getContentPane();
    private JScrollPane jScrollPane1;
    private JTextArea textArea;
    JFileChooser fileChooser = new JFileChooser();
    File fileName;                                                 // input path
    File outputFile;                                              // output path
    File defaultPath;                                 // normally user/documents
    File savePathNamePath;                     // pathname of saving latest path
    File savePathName;                       // pathname of saving pathname file
    private Scanner inputPath;                            // reading latest path
    private String defaultPathS;
    private String savePathNameS = "savePath_EditFiles.txt";
    private Scanner input;
    private Formatter output;
    private Formatter outputPath;                     //writing latest used path
    private File[] inputs = null;
    private int ind = -1;                            // pointing to inputs table
    private boolean once = true;                             // only once switch
    private int catalogs = 0;              // number of catalogs having searched
    private int files = 0;       // number of files having searched in a catalog
    private int filesTot = 0;                            // total count of files
    private int latestSCount = 0;              // replaced string in latest file
    private int totStrings = 0;          // total deleted/replaced/added strings
    private int inRecords = 0;                         // count of input records
    private int totalInRecords = 0;              // total count of input records
    private int otRecords = 0;                        // count of output records
    private int totalOtRecords = 0;              // totalcount of output records
    private int lowerCount = 0;       // count of records converted to lowercase
    private int lowerCountTot = 0;           // total count of lowercase records
    private int upperCount = 0;       // count of records converted to UPPERcase
    private int upperCountTot = 0;  // total count of records converted to UPPER
    private int hylatyt = 0;                       // count of discarded records
    private int hylatytTot = 0;              // total count of discarded records
    private String line;                                         // input record
    private String line2;                       // second input record of a pair
    private String beginS;                      // beginning string to be edited
    private String endS;                  // ending string to be edited or empty
    private String replaceS;                        // replacing string or empty
    private String restOfRecord;                     // the rest of input record
    private String startingPart = "";                  // staring part of record
    private String skipTag = "";                   // f.ex. "<script" or "<?php"
    private String skipTagEnd = "";                 // f.ex. "</script>" or "?>"
    private boolean nLinesSearch = false; // searching string only 1 line (or 2)
    private boolean nowSkipping = false;                     // skipping forward
    private boolean simulateOnly = false;           // no output writing if true
    private boolean noPrint = false; // user doen´t want any verification if true
    private boolean add = false;                     // no replace - add if true
    private boolean addSave;          // otherwise final report would show wrong
    private boolean addB = false;                     // add to beginning string
    private boolean addE = false;                           // add to end string
    private final int SIZE = 10;                          // size of skip tables
/* sCountsTot and sCountsText and scriptCounts are in same order (sCountText) */
    private int sCountsTot[] = new int[SIZE];
    private String sCountsText[] = new String[SIZE];
    private int[] scriptCounts = new int[SIZE];
    /*************************************************************/
    //skipText, ifSkip in same order (index pointing to last)
    private final int START = 0;                      // index of skipText table
    private final int END = 1;                        // index of skipText table
    private String skipText[][] = new String[SIZE][2];  // startskip and endskip
    private final int GEN = 0;          // generally skip option selected switch
    private final int NOW = 1;                                   // skipping now
    private boolean ifSkip[][] = new boolean[SIZE][2];       // GEN and NOW skip
    private int indexIf = -1;                              // ifSkip table index
    private int chkInd = 0;       // points to first free slot in table skipText
    private int filesave[] = new int[SIZE];          // latest scriptcounts save
    private int stringsSave = 0;    //latest replaced/deleted/added strings save
    private int nowSkipCount = 0;                           // latest skip count
    private boolean endSameLine;             // true if script ends in same line

    /*************************************************************/
    public EditFiles() {
        super("http://www.veikkoniemi.com/software/java/EditFiles");
        setLocation(300, 300);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        asetteleKomponentit();
        cSisalto.add(jpTiedot, BorderLayout.NORTH);
        cSisalto.add(jpCheckBoxes, BorderLayout.CENTER);
        cSisalto.add(jpPainikkeet, BorderLayout.SOUTH);
        setResizable(false);
        pack();
        btStart.addActionListener(new AlsKuuntelija());
        btFinish.addActionListener(new AlsKuuntelija());
        jCase.addActionListener(new AlsKuuntelija());
        nLines.addActionListener(new AlsKuuntelija());
        fHtml.addActionListener(new AlsKuuntelija());
        sScript.addActionListener(new AlsKuuntelija());
        sPhp.addActionListener(new AlsKuuntelija());
        simulate.addActionListener(new AlsKuuntelija());
        noVerify.addActionListener(new AlsKuuntelija());
        jcbadd.addActionListener(new AlsKuuntelija());
        for (int j = 0; j < skipText.length; j++) {
            skipText[j][START] = "";
            skipText[j][END] = "";
            sCountsText[j] = "";
        }
    }

        public static void main(String[] args) {
        EditFiles editF = new EditFiles();
        editF.setVisible(true);
    }

    private void asetteleKomponentit() {
        jpTiedot.setLayout(new GridLayout(5, 2, 10, 10));
        jpTiedot.add(lbBegin);
        jpTiedot.add(tfBegin);
        jpTiedot.add(lbEnd);
        jpTiedot.add(tfEnd);
        jpTiedot.add(lbReplace);
        jpTiedot.add(tfReplace);
        jpTiedot.add(lbStartSkip1);
        jpTiedot.add(tfStartSkip1);
        jpTiedot.add(lbEndSkip1);
        jpTiedot.add(tfEndSkip1);
        jpCheckBoxes.setLayout(new GridLayout(3, 3, 10, 10));
        jpCheckBoxes.add(fHtml);
        jpCheckBoxes.add(nLines);
        jpCheckBoxes.add(sScript);
        jpCheckBoxes.add(sPhp);
        JLabel caseLabel = new JLabel("To format:");
        jpCheckBoxes.add(caseLabel);
        jpCheckBoxes.add(jCase);
        jpCheckBoxes.add(simulate);
        jpCheckBoxes.add(noVerify);
        jpCheckBoxes.add(jcbadd);
        jpPainikkeet.setLayout(new GridLayout(1, 2, 10, 10));
        jpPainikkeet.add(btStart);
        jpPainikkeet.add(btFinish);
    }

    class AlsKuuntelija implements ActionListener {                 // listeners

        public void actionPerformed(ActionEvent klik) {

            if (klik.getSource() == fHtml) {                          // filtter
                filterHtml = fHtml.isSelected() ? true : false;
            }

            if (klik.getSource() == sScript) {                        // <script
                skipScript = sScript.isSelected() ? true : false;
                setControls(skipScript, "<script", "</script>");
            }

            if (klik.getSource() == sPhp) {                             // <?php
                skipPhp = sPhp.isSelected() ? true : false;
                setControls(skipPhp, "<?php", "?>");
            }

            if (klik.getSource() == jCase) {                // JComboBox 3 items

                int valittu = jCase.getSelectedIndex();
                caseLine = false;
                lowerLine = false;
                upperLine = false;
                switch (valittu) {
                    case 0:
                        caseLine = true;
                        break;
                    case 1:
                        lowerLine = true;
                        int answer = JOptionPane.showConfirmDialog(rootPane,
                                "Do you really want to convert all lines to lower case?");

                        switch (answer) {
                            case JOptionPane.YES_OPTION:
                                break;
                            case JOptionPane.NO_OPTION:
                                jCase.setSelectedIndex(0); // set to "case"
                                break;
                            case JOptionPane.CANCEL_OPTION:
                                attention("Skipped lines will not be  converted to " +
                                        "lower case\nChoose once more");
                                jCase.setSelectedIndex(0); // set to "case"
                        }
                        break;
                    case 2:
                        upperLine = true;
                        answer = JOptionPane.showConfirmDialog(rootPane, "Do you really " +
                                "want to convert all lines to UPPER case?");
                        switch (answer) {
                            case JOptionPane.YES_OPTION:
                                break;
                            case JOptionPane.NO_OPTION:
                                jCase.setSelectedIndex(0);      // set to "case"
                                break;
                            case JOptionPane.CANCEL_OPTION:
                                attention("Skipped lines will not be  converted to " +
                                        "UPPER case\nChoose once more");
                                jCase.setSelectedIndex(0);      // set to "case"
                        }
                }
            }

            if (klik.getSource() == nLines) {        // checkBox 2 lines strings

                nLinesSearch = nLines.isSelected() ? true : false;
            }

            if (klik.getSource() == simulate) {             // checkBox simulate

                simulateOnly = simulate.isSelected() ? true : false;
            }

            if (klik.getSource() == noVerify) {             // checkBox noVerify

                noPrint = noVerify.isSelected() ? true : false;
            }

            if (klik.getSource() == jcbadd) {        // checkBox no replace -ADD
                add = checkAdd();
                if (add) {
                    add = jcbadd.isSelected() ? true : false;
                } else {
                    jcbadd.setSelected(false);
                    add = false;
                }
            }

            if (klik.getSource() == btStart) {                   // start button
                if (checkCase()) {                      // are we ready to start
                    run();                      // everything is ok - lets start
                    jcbadd.setSelected(false);                      // init add
                    addSave = add;
                    add = false;
                }
            }

            if (klik.getSource() == btFinish) {                 // finish button
                for (int j = 0; j < filesave.length; j++) {
                    scriptCounts[j] = filesave[j];
                }
                if (noPrint) {
                }else{
                    latestSCount = stringsSave;
                    add = addSave;
                    for (int j = 0; j < scriptCounts.length; j++) {
                        if (sCountsText[j].length() > 0) {
                            scriptCounts[j] = filesave[j];
                        }
                    }
                }
                sumIt();
                System.exit(0);
            }
        }
    }

    private void setControls(Boolean set, String start, String end) {

        boolean found = false;                                  // skip controls
        if (set) {
            for (int j = 0; j < skipText.length; j++) {
                if (start.length() > 0) {
                    if (start.equalsIgnoreCase(skipText[j][START])) {
                        ifSkip[j][GEN] = true;
                        skipText[j][START] = start;
                        skipText[j][END] = end;
                        found = true;
                        break;
                    }
                }
            }
            if (found) {
            } else {
                indexIf++; // skipText and ifSkip tables always filled in order from beginning - pointing to last
                // if user deselects - then table is ordered again
                ifSkip[indexIf][GEN] = true;
                skipText[indexIf][START] = start;
                skipText[indexIf][END] = end;
                // counts controls may be in different order than skipcontrols
                // and they are never deleted during this program
                for (int j = 0; j < sCountsText.length; j++) {
                    // may already exist in table
                    if (sCountsText[j].equalsIgnoreCase("")) {
                        // slots are filled in order - this is first and available
                        sCountsText[j] = start;             // set up this count
                        break;
                    }
                    if (sCountsText[j].equalsIgnoreCase(start)) {
                        break;                     // counts are already counted
                    }
                }
            }

        } else {

            for (int j = 0; j < skipText.length; j++) {
                if (skipText[j][START].equalsIgnoreCase(start)) {
                    skipText[j][START] = "";
                    skipText[j][END] = "";
                    break;
                }
            }
            for (int j = 0; j < skipText.length; j++) {   // fill from beginning
                if (skipText[j][START].length() == 0) {
                    for (int k = j + 1; k < skipText.length; k++) {
                        if (skipText[k][START].length() > 0) {
                            skipText[j][START] = skipText[k][START];
                            skipText[j][END] = skipText[k][END];
                            skipText[k][START] = "";
                            skipText[k][END] = "";
                            break;
                        }
                    }
                }
            }
            indexIf--;
        }
    }

    private boolean checkAdd() {

        beginS = tfBegin.getText();
        if (beginS.length() == 0) {
            attention("Begin string empty");
        } else {
            endS = tfEnd.getText();
            replaceS = tfReplace.getText();
        }
        int a = replaceS.indexOf(beginS);
        int b = replaceS.indexOf(endS);
        addB = false;
        addE = false;
        if (a > -1) {
            addB = true;
            add = true;
            return true;
        } else {
            if (b > -1) {
                addE = true;
                add = true;
                return true;
            } else {
                attention("If you choose \"add\" then either beginstring" +
                        "\nor endstring must be included into replace string");
                add = false;
                return false;
            }
        }
    }

    private void adding(String helpS, int eInd) {
        // helpS = ending part of record starting from the end of beginS + starting part of line2 to the beginning of endS
        // eInd=index to the beginning of "endS" string
        if (addB) {                                // adding text to endS string
            startingPart += replaceS;                               // add start
            startingPart += helpS.substring(0, eInd) + endS;      // + xxx..endS
        } else {                                 // adding text to beginS string
            startingPart += beginS;
            startingPart += helpS.substring(0, eInd) + replaceS;
        }
    }

    private boolean searchStringA_B(String start, String end, String endings) {
        // returning startingPart + endings from string end
        // returning also true if string is found
        int a = endings.indexOf(start);

        if (a < 0) {
            startingPart += endings;
            restOfRecord = "";
            return false;                              // start string not found
        }                                                  // start string found
        //                                  endings=ab/start/defgh/start/ijklmno
        if (end.isEmpty()) {
            //   start found, a is pointing to start endings=startxxxxxstartxxxx
            while (!endings.isEmpty()) {
                latestSCount++;                            // start string found
                if (noPrint) {
                } else {
                    System.out.println("******replaced string " + latestSCount + " line=" + line);
                }
                startingPart += endings.substring(0, a);
                endings = endings.substring(a + start.length());   // skip start
                a = endings.indexOf(start); // endings=xxxstartxxx a>-1 or -1
                if (a > -1) {
                } else {
                    startingPart += endings; // +xxxxxx
                    endings = "";
                }
            }
            restOfRecord = "";
            return false;
        }                                               // end of "end" is empty
        startingPart += endings.substring(0, a);
        endings = endings.substring(a);
        line2 = "";
        String hEndings = endings.substring(0 + start.length());
        int b = hEndings.indexOf(end);                      // do we find end string
        if (b > -1) {
            latestSCount++;                              // end string was found
            if (noPrint) {
            } else {
                System.out.println("******replaced string " + latestSCount + " line=" + line);
            }
            if (add) {
                adding(hEndings, b);
            } else {
                startingPart += replaceS; // *************************** replace
            }
            if (b + endS.length() == hEndings.length()) {
                restOfRecord = "";    // endings string is ending to endS string
            } else {
                restOfRecord = hEndings.substring(b + endS.length());
            }
            return true;
        }
        //                                      string was not found on 1 record
        if (!nLinesSearch) {              // does it continues on second record?
            startingPart += endings;
            restOfRecord = "";
            return false;                            // no, string was not found
        }
        if (readNextRecord()) {
            line2 = line;
        } else {
            startingPart += endings;
            restOfRecord = "";
            return false;                  // end of file - string was not found
        }
        b = line2.indexOf(end);

        if (b < 0) {                           //if minus - end string not found
            startingPart = endings;
            restOfRecord = "";
            if (startingPart.length() > 0) {
                restOfRecord = line2;
                write(startingPart);
                startingPart = "";
            }
            return false;                                // end string not found
        } else {                         // string found ending on second record
            if (add) {
                adding(hEndings + line2.substring(0, b), hEndings.length() + b);
                startingPart += line2.substring(b + end.length());
            } else {
                startingPart += replaceS +
                        line2.substring(b + end.length()); // *************korvaa
            }
            latestSCount++;                        // count of this file strings
            if (noPrint) {
            } else {
                System.out.println("******replaced string " + latestSCount + " line=" + line);
            }
            restOfRecord = restOfRecord.substring(b + endS.length());
            if (line2.substring(b + end.length()).indexOf(start) > -1) {
                System.out.println("It's not allowed to start a new string\n" +
                        "from second string line\n" +
                        "line #" + inRecords + ". line=" + line2);
                attention("It's not allowed to start a new string\n" +
                        "from second string line\n" +
                        "line #" + inRecords + ". line=" + line2);
                System.exit(3);
            }
            restOfRecord = "";
            write(startingPart);
            startingPart = "";
        }
        return true;
    }

    private void write(String outLine) {
        if (outLine.length() > 0) {
            otRecords++;
            output.format("%s\n", outLine);
        } else {
            hylatyt++;
        }
        if (simulateOnly) {
            if (noPrint) {
            } else {
                System.out.println("out #     " + otRecords + ".    =" + outLine);
            }

        }
    }

    private boolean testEnd(String skipT, String skipTagE) {
        //                        returning true if skipping (also 1 line skips)
        if (ifSkip[chkInd][NOW]) {
            if (skipTagE.equalsIgnoreCase("") || endSameLine) { // 1 line skip only
                ifSkip[chkInd][NOW] = false;
                nowSkipping = false;
                for (int j = 0; j < scriptCounts.length; j++) {
                    if (skipText[chkInd][START].equalsIgnoreCase(sCountsText[j])) {
                        scriptCounts[j]++;                         // add only 1
                        break;
                    }
                }
                nowSkipCount = 0;
                return true;                                      // 1 line skip
            } else {
                int ns = line.toLowerCase().indexOf(skipTagE.toLowerCase());
                if (ns > -1) {                            // do we end skipping?
                    ifSkip[chkInd][NOW] = false;             // finnish skipping
                    nowSkipping = false;
                    if (noPrint) {
                    } else {
                        System.out.println("***************************************" +
                                "**" + " stopping skip " + skipTagE + " record # " + inRecords);
                    }
                    for (int j = 0; j < scriptCounts.length; j++) {
                        if (skipText[chkInd][START].equalsIgnoreCase(sCountsText[j])) {
                            scriptCounts[j] += ++nowSkipCount;
                            break;
                        }
                    }
                    nowSkipCount = 0;
                    write(line);
                    return true;
                } else {
                    nowSkipCount++;
                    write(line);
                    return true;
                }
            }
        }
        return false;                                           // normal record
    }

    private boolean testStart(boolean chkbox, boolean skipping, String skipT, String skipTagE) {
        //                        returning true if starting or already skipping
        // returning false on 1 line skips
        if (chkbox) {                               // is chkbox option selected
            if (skipping) {                          // are we already skipping?
                return true;                    // so not testing skipping start
            }                                   // no - do we start new skipping
            boolean b1 = line.toLowerCase().indexOf(skipText[chkInd][START].toLowerCase()) > -1;
            if (b1) {                                        // starting to skip

                ifSkip[chkInd][NOW] = true;
                nowSkipping = true;
                skipTag = skipText[chkInd][START];
                skipTagEnd = skipText[chkInd][END];
                nowSkipCount++;
                endSameLine = skipTagE.length() > 0 &&
                        line.toLowerCase().indexOf(skipTagE) > -1;
                if (noPrint) {
                    if (skipTagE.equalsIgnoreCase("") || endSameLine) { // 1 line skip
                        return false;
                    }
                } else {
                    if (skipTagE.equalsIgnoreCase("") || endSameLine) { // 1 line skip
                        System.out.println("*** skipped record #" + inRecords + " " + line); // 1 line skip
                        return false;              // returning to normal record
                    } else {
                        System.out.println("*******************" + " Starting " +
                                "to skip " + skipText[chkInd][START] + " record #=" + inRecords);
                    }
                }
                write(line);
                return true;                                 // starting to skip
            }
        }                                                 // chkbox not selected
        return false;                             // normal record - no skipping
    }

    private boolean readNextRecord() {
        //             returning true and line = restOfRecord if not end of file
        while (input.hasNext()) {

            line = input.nextLine();
            inRecords++;
            if (simulateOnly) {
                if (noPrint) {
                } else {
                    System.out.println("in  # " + inRecords + ".        =" + line);
                }
            }
            restOfRecord = line;
            endSameLine = false;
            if (nowSkipping) {
                //                                           now we are skipping
                if (testEnd(skipTag, skipTagEnd)) {
                    continue; // while loop - read next record
                } //                         when skipping - returns always true
            } else {
                //                                   testing if we start to skip
                for (int i = 0; i < ifSkip.length; i++) {
                    if (ifSkip[i][GEN]) {
                        //                   This skip option selected generally
                        if (skipText[i][START].isEmpty()) {
                            toCase();  //                           normal line
                            return true;                    // record to editing
                        }
                        chkInd = i;
                        if (skipText[i][START].length() > 0) {
                            if (testStart(ifSkip[i][GEN], ifSkip[i][NOW], skipText[i][START], skipText[i][END])) {
                                // starting to skip ifSkip[i][NOW] is set in testStart
                                break;                        // out of for loop
                            } // not starting to skip (either normal line or 1 line skip)
                            if (testEnd(skipText[i][START], skipText[i][END])) {
                                break;             // skipping - out of for loop
                            }
                        }
                    }                         // end if skipping option selected
                }                                                // end for loop
                if (ifSkip[chkInd][NOW]) {
                    continue;      // skip - to the while loop to read next line
                }                                  // normal line or 1 line skip
                if (endSameLine || (skipText[chkInd][END].equalsIgnoreCase("") &&
                        line.toLowerCase().indexOf(skipText[chkInd][START].toLowerCase()) > -1)) { // if 1 line skip
                    write(line);
                    continue;                                     // skip 1 line
                } else {
                    toCase();
                }
                return true;
            }                                       // end not skipping just now
        }
        return false;             // end while reading record loop - end of file
    }                     // end of method readNextRecord - line has a new value

    private void toCase() {
        if (!caseLine) {
            if (lowerLine) {
                lowerCount++;
                line = line.toLowerCase();
                if (noPrint) {
                } else {
                    System.out.println("# " + lowerCount + " to lowercase=" + line);
                }
            } else {
                if (upperLine) {
                    upperCount++;
                    line = line.toUpperCase();
                    if (noPrint) {
                    } else {
                        System.out.println("# " + upperCount + " to UPPERcase=" + line);
                    }
                }
            }
        }
        restOfRecord = line;
    }

    private void sumIt() {
        String simulateText = "";
        if (simulateOnly) {
            simulateText = "\n*** All previous info was a simulation ***";
        }
        String hlp = "";
        for (int j = 0; j < scriptCounts.length; j++) {
            if (sCountsText[j].length() > 0) {
                hlp += scriptCounts[j] + " " + sCountsText[j] + " Skipped lines this file \n";
                hlp += sCountsTot[j] + " " + sCountsText[j] + " Skipped lines total \n";
            }
        }
        attention("OPTIOS: EDIT BEGIN=\"" + beginS +
                "\", EDIT END=\"" + endS + "\", REPLACE=\"" + replaceS + "\"" +
                "\nFilter htm/html/php=" + filterHtml + ",      2 line strings=" +
                nLinesSearch +
                "\nskip <script=" + skipScript + ",      skip <?php=" + skipPhp +
                "\nTo format: case=" + caseLine + ", to lower case=" +
                lowerLine + ", to UPPER case=" + upperLine +
                "\nSimulation=" + simulateOnly + ",          No verify=" + noPrint +
                "\nno replace - ADD=" + add +
                "\n\n" + catalogs + " Edited catalogs\n" +
                filesTot + " Total files\n" +
                fileName + " =Latest file name \n" +
                latestSCount + " Replaced/deleted/added " + " strings\n" +
                totStrings + " Total count of replaced/deleted/added strings \n" +
                lowerCount + " records converted to lower case\n" +
                lowerCountTot + " total records converted to lower case\n" +
                upperCount + " records converted to UPPER case\n" +
                upperCountTot + " total records converted to UPPER case\n" +
                hlp +
                inRecords + " Records read \n" +
                hylatyt + " Empty, discarded records \n" +
                otRecords + " Records written \n" +
                "********************************************\n" +
                totalInRecords + " Total records read \n" +
                hylatytTot + " Total empty, discarded records \n" +
                totalOtRecords + " Total records written \n" + simulateText);

        System.out.println("OPTIOS: EDIT BEGIN=\"" + beginS +
                "\", EDIT END=\"" + endS + "\", REPLACE=\"" + replaceS + "\"" +
                "\nFilter htm/html/php=" + filterHtml + ",      2 line strings=" +
                nLinesSearch +
                "\nskip <script=" + skipScript + ",      skip <?php=" + skipPhp +
                "\nTo format: case=" + caseLine + ", to lower case=" +
                lowerLine + ", to UPPER case=" + upperLine +
                "\nSimulation=" + simulateOnly + ",          No verify=" + noPrint +
                "\nno replace - ADD=" + add +
                "\n\n" + catalogs + " Edited catalogs\n" +
                filesTot + " Total files\n" +
                fileName + " =Latest file name \n" +
                latestSCount + " Replaced/deleted/added " + " strings\n" +
                totStrings + " Total count of replaced/deleted/added strings \n" +
                lowerCount + " records converted to lower case\n" +
                lowerCountTot + " total records converted to lower case\n" +
                upperCount + " records converted to UPPER case\n" +
                upperCountTot + " total records converted to UPPER case\n" +
                hlp +
                inRecords + " Records read \n" +
                hylatyt + " Empty, discarded records \n" +
                otRecords + " Records written \n" +
                "********************************************\n" +
                totalInRecords + " Total records read \n" +
                hylatytTot + " Total empty, discarded records \n" +
                totalOtRecords + " Total records written \n" + simulateText);
    }

    private void sumItx() {
        for (int j = 0; j < filesave.length; j++) {
            filesave[j] = scriptCounts[j];
            scriptCounts[j] = 0;
        }
    }

    private boolean checkCase() {          // checks if case option is incorrect
        if (upperLine) {
            if (tfBegin.getText().toUpperCase().compareTo(tfBegin.getText()) != 0) {
                attention("Search fields must be in same case than your \"Case\"-choice\n" +
                        "be nice and select your options again");
                return false;
            }
        } else {
            if (lowerLine) {
                if (tfBegin.getText().toLowerCase().compareTo(tfBegin.getText()) != 0) {
                    attention("Search fields must be in same case than your \"Case\"-choice\n" +
                            "be nice and select your options again");
                    return false;
                }
            }
        }
        return true;
    }

    private void deselect() {
        for (int j = 0; j < skipText.length; j++) {
            if (skipText[j][START].equalsIgnoreCase(prevValue1)) {
                skipText[j][START] = "";
                skipText[j][END] = "";
                ifSkip[j][GEN] = false;
                break;
            }
        }
        for (int j = 0; j < skipText.length; j++) {       // fill from beginning
            if (skipText[j][START].length() == 0) {
                for (int k = j + 1; k < skipText.length; k++) {
                    if (skipText[k][START].length() > 0) {
                        skipText[j][START] = skipText[k][START];
                        skipText[j][END] = skipText[k][END];
                        skipText[k][START] = "";
                        skipText[k][END] = "";
                        break;
                    }
                }
            }
        }
        indexIf--;
    }

    private void doit() {
        inRecords = 0;
        otRecords = 0;
        lowerCount = 0;
        upperCount = 0;
        int i = 0;
        hylatyt = 0;
        latestSCount = 0;
        for (int j = 0;j < scriptCounts.length; j++){
            scriptCounts[j] = 0;
        }
        while (readNextRecord()) {   // reading whole input file through
            startingPart = "";
            while (!restOfRecord.isEmpty()) {
                searchStringA_B(beginS, endS, restOfRecord);
            }
            if (startingPart.length() > 0) {
                write(startingPart);
                startingPart = "";
            } else {
                if (line.length() > 0) {
                    if (noPrint) {
                    } else {
                        System.out.println("Discarded record # " + inRecords + ". " + line);
                    }
                } else {
                    if (noPrint) {
                    } else {
                        System.out.println("Empty record # " + inRecords);
                    }
                }
                hylatyt++;
            }
        }
        hylatytTot += hylatyt;
        totalInRecords += inRecords;
        totalOtRecords += otRecords;
        lowerCountTot += lowerCount;
        upperCountTot += upperCount;
        totStrings += latestSCount;
        nowSkipping = false;   // if latest file ended with skipping without end
        for (int j = 0; j < scriptCounts.length; j++) {
            for (int k = 0; k < scriptCounts.length; k++) {
                if (sCountsText[j].length() > 0) {
                    if (sCountsText[j].equalsIgnoreCase(skipText[k][START])) {
                        sCountsTot[j] += scriptCounts[j];
                    }
                }
            }
        }
    }

    private void run() {
        files = 0;
        beginS =
                tfBegin.getText();
        if (beginS.length() == 0) {
            attention("Begin string empty");
        } else {
            endS = tfEnd.getText();
            replaceS = tfReplace.getText();
            int a = replaceS.indexOf(beginS);
            int b = replaceS.indexOf(endS);
            if (tfStartSkip1.getText().isEmpty()) {
                if (prevValue1.length() > 0) {  // previous value to be deselect
                    deselect();
                }
            } else {
                ifSkip[indexIf][GEN] = true;
                setControls(ifSkip[indexIf][GEN], tfStartSkip1.getText(), tfEndSkip1.getText());
            }
            if (add) {
                if (replaceS.isEmpty()) {
                    attention("Replace string is empty - Cant add anything\n" +
                            "Option changed to false");
                    add = false;
                }
            } else {            // check if user still wants to add (no replace)
                boolean ask = false;
                if (a > -1 && replaceS.length() > 0) {
                    ask = true;
                } else {
                    if (b > -1 && replaceS.length() > 0) {
                        ask = true;
                    }
                }
                if (ask) {
                    int an = JOptionPane.showConfirmDialog(null, "Do you want to ADD - no " +
                            "replace strings?", "Choose one", JOptionPane.YES_NO_OPTION);
                    if (an == JOptionPane.YES_OPTION) {
                        add = checkAdd();
                    } else {
                        add = false;
                    }
                }
            }
            ind = -1;
            while (ind < 0 || ind < inputs.length) {      // can be many inputs

                openInput();
                openOutput();

                doit(); // replace or delete or add startstring, endstring

                closeInput();

                closeOutput();

//                                                          copy output to input
                if (simulateOnly) {                       // not when simulating
                } else {
                    openInput2();

                    openOutput2();

                    copyOutputToInput();

                    closeInput();

                    closeOutput();
                }
                ind++;

                files++;

                filesTot++;
                prevValue1 = tfStartSkip1.getText();                
                if (noPrint) {
                } else {
                    sumIt();
                }
                sumItx();
                stringsSave = latestSCount;
                latestSCount = 0;
            }
            try {
                outputFile.delete();
            } catch (SecurityException ex) {
                attention("Can´t delete file " + outputFile);
            }
            latestSCount = stringsSave;
            add = addSave;
            if (noPrint) {
                for (int j = 0; j < scriptCounts.length; j++) {
                    if (sCountsText[j].length() > 0) {
                        scriptCounts[j] = filesave[j];
                    }
                }
                sumIt();                              // only once / one catalog
            }
        }
    }

    private void openInput() {
        if (ind < 0) {         // in file savePath_EditFiles.txt is default path

            if (once) {
                once = false;
                savePathNamePath =
                        fileChooser.getCurrentDirectory();
            }

            defaultPath = fileChooser.getCurrentDirectory();
            defaultPathS =
                    defaultPath.getParent();
            if (noPrint) {
            } else {
                System.out.println("default path: " + defaultPathS);
            }

            Boolean savePathFileB = true;
            try {
                inputPath = new Scanner(new File(savePathNamePath, savePathNameS));
            } catch (FileNotFoundException ex) {
                attention("" + ex);
                savePathFileB =
                        false;
            }

            if (savePathFileB) {
                String savePathFileS = inputPath.nextLine().trim();
                if (noPrint) {
                } else {
                    System.out.println("savePathFileString=" + savePathFileS);
                }

                inputPath.close();
                File savePathFile = new File(savePathFileS);
                fileChooser.setCurrentDirectory(savePathFile);
            }

// ****************************************************************
            JOptionPane.showMessageDialog(null, "Navigate to the catalog of files to be edited");
            if (filterHtml) {
                FileNameExtensionFilter filter = new FileNameExtensionFilter(
                        "htm/html/php files only", "htm", "html", "php");
                fileChooser.setFileFilter(filter);
            } else {
                FileFilter allFiles = fileChooser.getAcceptAllFileFilter();
                fileChooser.setFileFilter(allFiles);
            }

            fileChooser.setMultiSelectionEnabled(true);
            int result = fileChooser.showOpenDialog(this);
            if (result == JFileChooser.CANCEL_OPTION) {
                error("Can't edit - no inputfile - Cancel chosen");
                System.exit(1);
            }

            inputs = fileChooser.getSelectedFiles();
            ind = 0;                                               // next input

            catalogs++;

        }


        fileName = inputs[ind];
        try {
            input = new Scanner(fileName);
        } catch (FileNotFoundException ex) {
            error("File not found\n" + ex);
        }

        fileChooser.setCurrentDirectory(fileName);
        if (noPrint) {
        } else {
            System.out.println("\n*************************************************" +
                    "\nNext input is " + fileName);
        }

    }

    private void closeInput() {
        input.close();
    }

    private void closeOutput() {
        output.close();
    }

    private void openInput2() {
        // open input
        try {
            input = new Scanner(outputFile);                 // output ==> input

        } catch (FileNotFoundException ex) {
            error("File not found " + outputFile + "\n" + ex);
        }
    }

    private void openOutput2() {
        // open output
        fileChooser.setCurrentDirectory(fileName);
        try {
            fileName.createNewFile();
        } catch (IOException ex) {
            System.err.println("Error2=" + ex);
            System.exit(2);
        }

        try {
            output = new Formatter(fileName); //                input ==> output

        } catch (FileNotFoundException filesNotFoundException) {
            error("errorkoodi=" + filesNotFoundException);
            System.exit(1);
        }

    }

    private void copyOutputToInput() {

        while (input.hasNext()) {
            line = input.nextLine();
            output.format("%s\n", line);

        }
    }

    private void openOutput() {

        outputFile = new File(fileName.getParent(), "EditFiles_temporaryOutput.txt");
        // always only this file

        try {
            outputFile.createNewFile();
        } catch (IOException ex) {
            error("Can´t create file " + outputFile);
        }

        try {
            output = new Formatter(outputFile);
        } catch (FileNotFoundException filesNotFoundException) {
            error("File not found when accessing output file " + fileName);
            System.exit(1);
        }
        // write output path string up to a file for next time
        if (!simulateOnly) {
            fileChooser.setCurrentDirectory(defaultPath);
            savePathName =
                    new File(savePathNamePath, savePathNameS);
            try {
                savePathName.createNewFile();
            } catch (IOException ex) {
                error("Can´t create file " + savePathNameS);
            }

            try {
                outputPath = new Formatter(savePathName);
            } catch (FileNotFoundException filesNotFoundException) {
                error("File not found when accessing output file " + fileName);
                System.exit(1);
            }

            outputPath.format("%s\n", outputFile.getParent());
            outputPath.close();                                // close pathFile
        }                       // code up is executed only if we don't simulate
    }

    private void error(String show) {
        JOptionPane.showMessageDialog(this, show, "error", JOptionPane.ERROR_MESSAGE);
    }

    private void attention(String show) {
        JOptionPane.showMessageDialog(this, show, "attention", JOptionPane.INFORMATION_MESSAGE);
    }
}